;	 _____________________________________________________________________________________
;	*
;	*       .     .       *
;	*_____________________________________________________________________________________

	list		p=16f876		; ,   
	#include	<p16f876.inc>		;     MPLAB
	radix		hex			;    

;			---    ---

  __CONFIG _CP_OFF & _WDT_OFF & _BODEN_ON & _PWRTE_ON & _HS_OSC & _WRT_ENABLE_OFF & _LVP_OFF & _DEBUG_OFF & _CPD_OFF

; 			---  ---

;	          PORTB

RW		EQU	1			; R/_W -  RB1
E		EQU	2			; E    -  RB2
RS		EQU	3			; RS   -  RB3

; 			---  ---

jnz		MACRO	m01			; ,
		btfss	STATUS,Z		;   0
		goto	m01
		endm
jz		MACRO	m02			; ,
		btfsc	STATUS,Z		;  0
		goto	m02
		endm
jnc		MACRO	m03			; ,
		btfss	STATUS,C		;   
		goto	m03
		endm
jc		MACRO	m04			; ,
		btfsc	STATUS,C		;  
		goto	m04
		endm

mov		MACRO   MDEST1,MSOURCE1		;  - ( W)
		movf    MSOURCE1,W
		movwf   MDEST1
		endm
mvi		MACRO   MDEST2,MCONST2		;     ( W)
		movlw   MCONST2
		movwf   MDEST2
		endm

;			---   ---

W_copy		EQU	070h			;  
ST_copy		EQU	071h			;  
TEMP1		EQU	072h			;     

OUTLCD		EQU	073h			;     

SRC0		EQU	074h			;     hex-->dec
SRC1		EQU	075h
RES0		EQU	076h			;   hex-->dec
RES1		EQU	077h
RES2		EQU	078h
RES3		EQU	079h
COUNTER		EQU	07Ah			; 

BYTE00		EQU	020h			;    
BYTE01		EQU	021h			;    
BYTE02		EQU	022h
BYTE03		EQU	023h
BYTE04		EQU	024h
BYTE05		EQU	025h
BYTE06		EQU	026h
BYTE07		EQU	027h
BYTE08		EQU	028h
BYTE09		EQU	029h
BYTE0A		EQU	02Ah
BYTE0B		EQU	02Bh
BYTE0C		EQU	02Ch
BYTE0D		EQU	02Dh
BYTE0E		EQU	02Eh
BYTE0F		EQU	02Fh

BYTE10		EQU	030h
BYTE11		EQU	031h
BYTE12		EQU	032h
BYTE13		EQU	033h
BYTE14		EQU	034h
BYTE15		EQU	035h
BYTE16		EQU	036h
BYTE17		EQU	037h
BYTE18		EQU	038h
BYTE19		EQU	039h
BYTE1A		EQU	03Ah
BYTE1B		EQU	03Bh
BYTE1C		EQU	03Ch
BYTE1D		EQU	03Dh
BYTE1E		EQU	03Eh
BYTE1F		EQU	03Fh

ADRSAVE0	EQU	040h
ADRSAVE1	EQU	041h
ADRSAVE2	EQU	042h
ADRSAVE3	EQU	043h
ADRSAVE4	EQU	044h
ADRSAVE5	EQU	045h
ADRSAVE6	EQU	046h
ADRSAVE7	EQU	047h

;			---  ---
		ORG 0				;  
Reset		bcf	STATUS,RP1
		bcf	STATUS,RP0		;  0
		bcf	STATUS,IRP
		goto	Start
;			_____________________________

;			---   ---
;			_____________________________

		ORG 4				;   (   GIE)
Int_begin	movwf     W_copy                ;  
		mov       ST_copy,STATUS



Int_end		mov	STATUS,ST_copy		;  
		swapf	W_copy,F		; ( swapf  
		swapf	W_copy,W		;      STATUS)
		retfie				;       GIE

;			________________________

;			---      ---
;			________________________
;---------------------------------------------------------------------------------------------
                ; - (  W -  2  255 )

		; : W

uPause		addlw	0FFh			;call+addlw+return = 0.4+0.2+0.4 = 1 
uP_label	addlw	0FFh			;  W (1   )
		clrwdt
		jnz	uP_label
		nop
		return				;  -
;---------------------------------------------------------------------------------------------
		;  (  W -  1  255  + 1 )

		; : W, TEMP1.
		; clrwdt   nop  

mPause		movwf	TEMP1
mP1_label	movlw	D'250'
mP2_label	addlw	0FFh
		clrwdt
		jnz	mP2_label
		clrwdt
		movlw	D'250'
mP3_label	addlw	0FFh
		clrwdt
		jnz	mP3_label
		movlw	D'250'
mP4_label	addlw	0FFh
		clrwdt
		jnz	mP4_label
		movlw	D'249'
mP5_label	addlw	0FFh
		clrwdt
		jnz	mP5_label
		clrwdt
		decfsz	TEMP1,F
		goto	mP1_label
		clrwdt
		return
;---------------------------------------------------------------------------------------------
                ;      4- .
		;=250    call  return (50   20 )

		; : TEMP1, OUTLCD, PORTB

Txir_lcd	movwf	TEMP1			; ,  ,   TEMP1
		andlw	B'11110000'		;     
		movwf	OUTLCD			;      
		bsf	OUTLCD,E		;    
		mov	PORTB,OUTLCD		;     
		clrwdt				;  
		bcf	OUTLCD,E		;      -    
		mov	PORTB,OUTLCD		;     

		swapf	TEMP1,W			;  ,   W
		andlw	B'11110000'		;   ,  
		movwf	OUTLCD			;      
		bsf	OUTLCD,E		;    
		mov	PORTB,OUTLCD		;     
		clrwdt				;  
		bcf	OUTLCD,E		;      -    
		mov	PORTB,OUTLCD		;     

		movlw	B'00000001'		;   ,  
		andwf	OUTLCD,F		; (  0   )
		mov	PORTB,OUTLCD		;

		movlw	D'44'			;  
		call	uPause
		clrwdt

		return				;    
;---------------------------------------------------------------------------------------------
                ;       4- .
		;=200    call  return (40   20 )

		; : TEMP1, OUTLCD, PORTB

Txd_lcd		movwf	TEMP1			; ,  ,   TEMP1
		andlw	B'11110000'		;     
		movwf	OUTLCD			;      
		bsf	OUTLCD,RS		;    RS=1
		mov	PORTB,OUTLCD		;     
		bsf	OUTLCD,E		;    
		mov	PORTB,OUTLCD		;     
		clrwdt				;  
		bcf	OUTLCD,E		;      -    
		mov	PORTB,OUTLCD		;     

		swapf	TEMP1,W			;  ,   W
		andlw	B'11110000'		;   ,  
		movwf	OUTLCD			;      
		bsf	OUTLCD,RS		;    RS=1
		mov	PORTB,OUTLCD		;     
		bsf	OUTLCD,E		;    
		mov	PORTB,OUTLCD		;     
		clrwdt				;  
		bcf	OUTLCD,E		;      -    
		mov	PORTB,OUTLCD		;     

		movlw	B'00000001'		;   ,  
		andwf	OUTLCD,F		; (  0   )
		mov	PORTB,OUTLCD		;

		movlw	D'33'			;   33 
		call	uPause

		return				;       
;---------------------------------------------------------------------------------------------
		;  16-    -
		;=876    call  return (175.2   20 )

		; : TEMP1, COUNTER,
		;			SRC0, SRC1, ( )
		;			RES0, RES1, RES2, RES3 ()

Hex2dec		clrf	RES2			;    (3  - 5 )
		clrf	RES1			;  bbbbbbbb bbbbbbbb --> 0000|dddd dddd|dddd dddd|dddd -
		clrf	RES0			; -> 0000|dddd 0000|dddd 0000|dddd 0000|dddd

		movlw	D'16'			;   
		movwf	COUNTER			; 
		goto	Shift

Next		movf	RES0,W
		call 	Correct	
		movwf	RES0
		movf	RES1,W
		call 	Correct
		movwf	RES1
		movf	RES2,W
		call 	Correct
		movwf	RES2

Shift		rlf	SRC0,F			;    
		rlf	SRC1,F			;    
		rlf	RES0,F			;   
		rlf	RES1,F
		rlf	RES2,F			;   
		decfsz	COUNTER,F		;  ?
		goto 	Next			;  - 

		clrf	SRC0
		clrf	SRC1

		mov	TEMP1,RES1		;   RES1  TEMP1
		swapf	RES0,W			;   RES0
		movwf	RES1			;    RES1

		movf	TEMP1,W
		movwf	RES3			;  ,    RES1 -  RES3
		mov	TEMP1,RES2		;   RES2  TEMP1
		mov	RES2,RES3		;   RES2 ,   RES3
		swapf	RES3,F			;   RES3
		movlw	B'00001111'		;     
		andwf	RES0,F			; : 
		andwf	RES1,F			;            
		andwf	RES2,F			;            
		andwf	RES3,F			;             (    TEMP1)

		return				;    Hex2dec

		;  (   Hex2dec)

Correct		movwf	TEMP1			; W --> TEMP1
		movlw	0x03			; 3 --> W
		addwf	TEMP1,F			; (TEMP1+3) --> TEMP1
		btfss	TEMP1,3			;    <8,    W  <5
		subwf	TEMP1,F			;         TEMP1

		movlw	0x30			;    
		addwf	TEMP1,F
		btfss	TEMP1,7
		subwf	TEMP1,F

		movf	TEMP1,W			;   W
		return				;   
;---------------------------------------------------------------------------------------------

;			______________________________

;			---       ---
;			______________________________

		;  

Start		movf	PORTA,F			;   
		movf	PORTB,F			;  
		movf	PORTC,F			; 

		clrf	INTCON			;   

		bsf	STATUS,RP0		;  1
		mvi	TRISA,B'11111111'	;   PORTA
		mvi	TRISB,B'00000000'	;   PORTB
		mvi	TRISC,B'11111111'	;   PORTC

		mvi	OPTION_REG,B'00000000'	;  OPTION_REG
		bcf	STATUS,RP0		;  0

		clrf	PORTA			;
		clrf	PORTB			;
		clrf	PORTC			;
;------------------------------------------------
		;  

LCDinit		movlw	D'15'			;   
		call	mPause
		movlw	030h
		call	Txir_lcd
		movlw	D'4'
		call	mPause
		movlw	030h
		call	Txir_lcd
		movlw	030h
		call	Txir_lcd
		movlw	D'3'
		call	mPause			;      

LCDset		movlw	B'00100010'		;  :
		call	Txir_lcd		;  4-
		movlw	D'2'
		call	mPause
		movlw	B'00101000'
		call	Txir_lcd		;  4-, 2 ,  5x8
		movlw	D'2'
		call	mPause
		movlw	B'00000001'
		call	Txir_lcd		;  , =0
		movlw	D'2'
		call	mPause
		movlw	B'00000010'		; AC=0,  DDRAM, ,
		call	Txir_lcd		;      DDRAM
		movlw	D'2'
		call	mPause
		movlw	B'00001100'		;     ,
		call	Txir_lcd		;   
		movlw	D'2'
		call	mPause
		movlw	B'00000110'		;      ,
		call	Txir_lcd		;  
		movlw	D'2'
		call	mPause			;  

		;  

		mvi	FSR,BYTE00
Clean_label	mvi	INDF,020h		;   ""
		incf	FSR,F			;  ...
		movlw	BYTE1F
		addlw	01h
		xorwf	FSR,W			;    ?
		jnz	Clean_label		;  - 

		movlw	02Ch			;  
		movwf	BYTE02
		movwf	BYTE0A
		movwf	BYTE12
		movwf	BYTE1A

		movlw	056h			;  V
		movwf	BYTE06
		movwf	BYTE0E
		movwf	BYTE16
		movwf	BYTE1E

		;  

ADCinit		bsf	STATUS,RP0
		mvi	ADCON1,B'10000001'	; AN0-AN2,AN4 -  , Vref=RA3, ..
		bcf	STATUS,RP0
		mvi	ADCON0,B'10000001'	; ., Tad=32Tosc=1.6 ,  0 ( 2)

		;  " - "

Ch0start	movlw	B'10000001'		;  0 ( 2)
		movwf	ADCON0			; 220    ( 44   20 )
		movlw	D'20'
		call	uPause			;     C_hold
break0		bsf	ADCON0,GO_DONE		;  A/D 
		movlw	D'20'
		call	uPause			;   

ADCwait0	btfsc	ADCON0,GO_DONE		;  - A/D  ?
		goto	ADCwait0		;   - ...

		bsf	STATUS,RP0		; 
		movf	ADRESL,W
		bcf	STATUS,RP0
		movwf	ADRSAVE0		; 
		movf	ADRESH,W		; 
		movwf	ADRSAVE1		;   (hex)

		bcf	STATUS,C		;   4     
		rlf	ADRSAVE0,F		; (Vref = 4.096 V)
		rlf	ADRSAVE1,F
		bcf	STATUS,C		;    ...
		rlf	ADRSAVE0,F
		rlf	ADRSAVE1,F
		clrwdt

Ch1start	movlw	B'10001001'		;  1 ( 3) - 
		movwf	ADCON0
		movlw	D'20'
		call	uPause			; 
break1		bsf	ADCON0,GO_DONE		; 
		movlw	D'20'
		call	uPause			; 
ADCwait1	btfsc	ADCON0,GO_DONE		; 
		goto	ADCwait1		; 
		bsf	STATUS,RP0		; 
		movf	ADRESL,W
		bcf	STATUS,RP0
		movwf	ADRSAVE2		; 
		movf	ADRESH,W		; 
		movwf	ADRSAVE3		; 
		bcf	STATUS,C		; 
		rlf	ADRSAVE2,F		; 
		rlf	ADRSAVE3,F
		bcf	STATUS,C		; 
		rlf	ADRSAVE2,F
		rlf	ADRSAVE3,F
		clrwdt

Ch2start	movlw	B'10010001'		;  2 ( 4) - 
		movwf	ADCON0
		movlw	D'20'
		call	uPause			; 
		bsf	ADCON0,GO_DONE		; 
		movlw	D'20'
		call	uPause			; 
ADCwait2	btfsc	ADCON0,GO_DONE		; 
		goto	ADCwait2		; 
		bsf	STATUS,RP0		; 
		movf	ADRESL,W
		bcf	STATUS,RP0
		movwf	ADRSAVE4		; 
		movf	ADRESH,W		; 
		movwf	ADRSAVE5		; 
		bcf	STATUS,C		; 
		rlf	ADRSAVE4,F		; 
		rlf	ADRSAVE5,F
		bcf	STATUS,C		; 
		rlf	ADRSAVE4,F
		rlf	ADRSAVE5,F
		clrwdt

Ch4start	movlw	B'10100001'		;  4 ( 7) - 
		movwf	ADCON0
		movlw	D'20'
		call	uPause			; 
		bsf	ADCON0,GO_DONE		; 
		movlw	D'20'
		call	uPause			; 
ADCwait4	btfsc	ADCON0,GO_DONE		; 
		goto	ADCwait4		; 
		bsf	STATUS,RP0		; 
		movf	ADRESL,W
		bcf	STATUS,RP0
		movwf	ADRSAVE6		; 
		movf	ADRESH,W		; 
		movwf	ADRSAVE7		; 
		bcf	STATUS,C		; 
		rlf	ADRSAVE6,F		; 
		rlf	ADRSAVE7,F
		bcf	STATUS,C		; 
		rlf	ADRSAVE6,F
		rlf	ADRSAVE7,F
		clrwdt


		mov	SRC0,ADRSAVE0		;    0 
		mov	SRC1,ADRSAVE1		;    
		call	Hex2dec
		movf	RES3,W			;        
		addlw	030h
		movwf	BYTE01
		movf	RES2,W
		addlw	030h
		movwf	BYTE03
		movf	RES1,W
		addlw	030h
		movwf	BYTE04
		movf	RES0,W
		addlw	030h
		movwf	BYTE05

		mov	SRC0,ADRSAVE2		;    1 
		mov	SRC1,ADRSAVE3		;    
		call	Hex2dec
		movf	RES3,W			;        
		addlw	030h
		movwf	BYTE09
		movf	RES2,W
		addlw	030h
		movwf	BYTE0B
		movf	RES1,W
		addlw	030h
		movwf	BYTE0C
		movf	RES0,W
		addlw	030h
		movwf	BYTE0D

		mov	SRC0,ADRSAVE4		;    2 
		mov	SRC1,ADRSAVE5		;    
		call	Hex2dec
		movf	RES3,W			;        
		addlw	030h
		movwf	BYTE11
		movf	RES2,W
		addlw	030h
		movwf	BYTE13
		movf	RES1,W
		addlw	030h
		movwf	BYTE14
		movf	RES0,W
		addlw	030h
		movwf	BYTE15

		mov	SRC0,ADRSAVE6		;    4 
		mov	SRC1,ADRSAVE7		;    
		call	Hex2dec
		movf	RES3,W			;        
		addlw	030h
		movwf	BYTE19
		movf	RES2,W
		addlw	030h
		movwf	BYTE1B
		movf	RES1,W
		addlw	030h
		movwf	BYTE1C
		movf	RES0,W
		addlw	030h
		movwf	BYTE1D

		;      

		mvi	FSR,BYTE00		;   
		movlw	B'10000000'
		call	Txir_lcd		;      

Row1_label	movf	INDF,W			;      ,
brtmp1		call	Txd_lcd			;     FSR ( )
brtmp2		incf	FSR,F			;  ...
		movlw	BYTE0F			; 
		addlw	01h
		xorwf	FSR,W			;    ?
		jnz	Row1_label		;  - 

		mvi	FSR,BYTE10		;      
		movlw	B'11000000'
		call	Txir_lcd		;      

Row2_label	movf	INDF,W			; ...
		call	Txd_lcd			; 
		incf	FSR,F			; 
		movlw	BYTE1F			; 
		addlw	01h
		xorwf	FSR,W			;    ?
		jnz	Row2_label		;  - 

		nop
		nop
		nop
		nop
		movlw	D'177'
		call	uPause			;    2500 

		goto	Ch0start
;------------------------------------------------

		goto	$

		end

